/[gentoo-x86]/eclass/autotools.eclass
Gentoo

Diff of /eclass/autotools.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.48 Revision 1.61
1# Copyright 1999-2005 Gentoo Foundation 1# Copyright 1999-2005 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/autotools.eclass,v 1.48 2006/10/16 08:12:01 flameeyes Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/autotools.eclass,v 1.61 2007/01/04 14:56:46 flameeyes Exp $
4# 4#
5# Author: Diego Pettenò <flameeyes@gentoo.org> 5# Author: Diego Pettenò <flameeyes@gentoo.org>
6# Enhancements: Martin Schlemmer <azarah@gentoo.org> 6# Enhancements: Martin Schlemmer <azarah@gentoo.org>
7# 7#
8# This eclass is for handling autotooled software packages that 8# This eclass is for handling autotooled software packages that
12 12
13inherit eutils libtool 13inherit eutils libtool
14 14
15_automake_atom="sys-devel/automake" 15_automake_atom="sys-devel/automake"
16_autoconf_atom="sys-devel/autoconf" 16_autoconf_atom="sys-devel/autoconf"
17if [[ -n ${WANT_AUTOMAKE} ]] && [[ ${WANT_AUTOMAKE} != "latest" ]]; then 17if [[ -n ${WANT_AUTOMAKE} ]]; then
18 case ${WANT_AUTOMAKE} in
19 # workaround while we have different versions of automake in arch and ~arch
20 latest) _automake_atom="|| ( =sys-devel/automake-1.10* =sys-devel/automake-1.9* )" ;;
18 _automake_atom="=sys-devel/automake-${WANT_AUTOMAKE}*" 21 *) _automake_atom="=sys-devel/automake-${WANT_AUTOMAKE}*" ;;
22 esac
19fi 23fi
20 24
21if [[ -n ${WANT_AUTOCONF} ]] ; then 25if [[ -n ${WANT_AUTOCONF} ]] ; then
22 case ${WANT_AUTOCONF} in 26 case ${WANT_AUTOCONF} in
23 2.1) _autoconf_atom="=sys-devel/autoconf-${WANT_AUTOCONF}*" ;; 27 2.1) _autoconf_atom="=sys-devel/autoconf-${WANT_AUTOCONF}*" ;;
24 2.5) _autoconf_atom=">=sys-devel/autoconf-2.59" ;; 28 latest | 2.5) _autoconf_atom=">=sys-devel/autoconf-2.59" ;;
25 esac 29 esac
26fi 30fi
27DEPEND="${_automake_atom} 31DEPEND="${_automake_atom}
28 ${_autoconf_atom} 32 ${_autoconf_atom}
29 sys-devel/libtool" 33 sys-devel/libtool"
33# Variables: 37# Variables:
34# 38#
35# AT_M4DIR - Additional director(y|ies) aclocal should search 39# AT_M4DIR - Additional director(y|ies) aclocal should search
36# AM_OPTS - Additional options to pass to automake during 40# AM_OPTS - Additional options to pass to automake during
37# eautoreconf call. 41# eautoreconf call.
42# AT_NOELIBTOOLIZE - Don't run elibtoolize command if set to 'yes',
43# useful when elibtoolize needs to be ran with
44# particular options
38 45
39# Functions: 46# Functions:
40# 47#
41# eautoreconf() - Should do a full autoreconf - normally what most people 48# eautoreconf() - Should do a full autoreconf - normally what most people
42# will be interested in. Also should handle additional 49# will be interested in. Also should handle additional
137 144
138eautoheader() { 145eautoheader() {
139 # Check if we should run autoheader 146 # Check if we should run autoheader
140 [[ -n $(autotools_check_macro "AC_CONFIG_HEADERS") ]] || return 0 147 [[ -n $(autotools_check_macro "AC_CONFIG_HEADERS") ]] || return 0
141 autotools_set_versions 148 autotools_set_versions
142 autotools_run_tool autoheader "$@" 149 NO_FAIL=1 autotools_run_tool autoheader "$@"
143} 150}
144 151
145eautoconf() { 152eautoconf() {
146 if [[ ! -f configure.ac && ! -f configure.in ]] ; then 153 if [[ ! -f configure.ac && ! -f configure.in ]] ; then
147 echo 154 echo
191 [[ ${WANT_AUTOCONF} == "latest" ]] && WANT_AUTOCONF="2.5" 198 [[ ${WANT_AUTOCONF} == "latest" ]] && WANT_AUTOCONF="2.5"
192 export WANT_AUTOCONF 199 export WANT_AUTOCONF
193 einfo "Requested autoconf ${WANT_AUTOCONF}" 200 einfo "Requested autoconf ${WANT_AUTOCONF}"
194 einfo "Using $(autoconf --version 2>/dev/null | head -n 1)" 201 einfo "Using $(autoconf --version 2>/dev/null | head -n 1)"
195 einfo "Using $(autoheader --version 2>/dev/null | head -n 1)" 202 einfo "Using $(autoheader --version 2>/dev/null | head -n 1)"
203 else
204 ewarn "QA Notice: \${WANT_AUTOCONF} variable unset. Please report on http://bugs.gentoo.org/"
196 fi 205 fi
197 206
198 if [[ -n ${WANT_AUTOMAKE} ]]; then 207 if [[ -n ${WANT_AUTOMAKE} ]]; then
208 local latest_automake
199 if [[ ${WANT_AUTOMAKE} == "latest" ]]; then 209 if [[ ${WANT_AUTOMAKE} == "latest" ]]; then
200 # Consider starting from 1.9, as that is stable everywhere. 210 latest_automake="latest: "
201 has_version '~sys-devel/automake-1.9' && WANT_AUTOMAKE="1.9" 211 for amver in 1.10 1.9 1.8 1.7 1.6; do
202 has_version '~sys-devel/automake-1.10' && WANT_AUTOMAKE="1.10" 212 WANT_AUTOMAKE="${amver}"
213 ROOT=/ has_version =sys-devel/automake-${amver}* && break
214 done
203 fi 215 fi
204 export WANT_AUTOMAKE 216 export WANT_AUTOMAKE
205 einfo "Requested automake ${WANT_AUTOMAKE}" 217 einfo "Requested automake ${latest_automake}${WANT_AUTOMAKE}"
206 einfo "Using $(automake --version 2>/dev/null | head -n 1)" 218 einfo "Using $(automake --version 2>/dev/null | head -n 1)"
207 einfo "Using $(aclocal --version 2>/dev/null | head -n 1)" 219 einfo "Using $(aclocal --version 2>/dev/null | head -n 1)"
220 else
221 ewarn "QA Notice: \${WANT_AUTOMAKE} variable unset. Please report on http://bugs.gentoo.org/"
208 fi 222 fi
209 223
210 autotools_version_sets="yes" 224 autotools_version_sets="yes"
211} 225}
212 226
213# Internal function to run an autotools' tool 227# Internal function to run an autotools' tool
214autotools_run_tool() { 228autotools_run_tool() {
215 local STDERR_TARGET="${T}/$$.out" 229 local STDERR_TARGET="${T}/$$.out"
216 local PATCH_TARGET="${T}/$$.patch"
217 local ris 230 local ris
218 231
219 echo "***** $1 *****" > ${STDERR_TARGET%/*}/$1-${STDERR_TARGET##*/} 232 echo "***** $1 *****" > ${STDERR_TARGET%/*}/$1-${STDERR_TARGET##*/}
220 echo >> ${STDERR_TARGET%/*}/$1-${STDERR_TARGET##*/} 233 echo >> ${STDERR_TARGET%/*}/$1-${STDERR_TARGET##*/}
221 234
222 ebegin "Running $@" 235 ebegin "Running $@"
223 $@ >> ${STDERR_TARGET%/*}/$1-${STDERR_TARGET##*/} 2>&1 236 $@ >> ${STDERR_TARGET%/*}/$1-${STDERR_TARGET##*/} 2>&1
224 ris=$? 237 ris=$?
225 eend ${ris} 238 eend ${ris}
226 239
227 if [[ ${ris} != 0 ]]; then 240 if [[ ${ris} != 0 && ${NO_FAIL} != 1 ]]; then
228 echo 241 echo
229 eerror "Failed Running $1 !" 242 eerror "Failed Running $1 !"
230 eerror 243 eerror
231 eerror "Include in your bugreport the contents of:" 244 eerror "Include in your bugreport the contents of:"
232 eerror 245 eerror

Legend:
Removed from v.1.48  
changed lines
  Added in v.1.61

  ViewVC Help
Powered by ViewVC 1.1.20